// Get current sensor readings when the page loads   
window.addEventListener('load', getReadings);   
 
// Create angle Chart 
var chartA = new Highcharts.Chart({ 
  chart:{  
    renderTo:'chart-tilt'  
  }, 
  series: [ 
    { 
      name: undefined,
      color: 'rgb(9, 133, 9)', // Change color of the line to red
    } 
  ], 
  title: {  
    text: 'Neigung Messverlauf' 
  }, 
  plotOptions: { 
    line: {  
      animation: false, 
      dataLabels: {  
        enabled: true  
      } 
    } 
  }, 
  xAxis: { 
    tickInterval: 1,
    type: 'logarithmic'
  }, 
  yAxis: { 
    title: {  
      text: 'Grad'  
    } 
  }, 
  credits: { 
    enabled: false  
}
}); 
// Create gravity Chart 
var chartT = new Highcharts.Chart({ 
  chart:{  
    renderTo:'chart-temp'  
  }, 
  series: [ 
    { 
      name: undefined,
      color: 'rgb(9, 133, 9)', // Change color of the line to red
    } 
  ], 
  title: {  
    text: 'Temperatur Messverlauf'  
  }, 
  plotOptions: { 
    line: {  
      animation: false, 
      dataLabels: {  
        enabled: true  
      } 
    } 
  }, 
  xAxis: { 
    tickInterval: 1,
    type: 'logarithmic'
  }, 
  yAxis: { 
    title: {  
      text: 'Celsius'  
    } 
  }, 
  credits: { 
    enabled: false  
} 
}); 
 
// Create Temperature Chart 
var chartB = new Highcharts.Chart({ 
  chart:{  
    renderTo:'chart-battery'  
  }, 
  series: [ 
    { 
      name: undefined,
      color: 'rgb(9, 133, 9)', // Change color of the line to red
    } 
  ], 
  title: {  
    text: 'Batterie Messverlauf'   
  }, 
  plotOptions: { 
    line: {  
      animation: false, 
      dataLabels: {  
        enabled: true  
      } 
    } 
  }, 
  xAxis: { 
    tickInterval: 1,
    type: 'logarithmic'
  }, 
  yAxis: { 
    title: {  
      text: 'Volt'  
    } 
  }, 
  credits: { 
    enabled: false  
} 
}); 
 
// Create Battery Chart 
var chartG = new Highcharts.Chart({ 
  chart:{  
    renderTo:'chart-gravity'  
  }, 
  series: [ 
    { 
      name: undefined,
      color: 'rgb(9, 133, 9)', // Change color of the line to red
    } 
  ], 
  title: {  
    text: 'Dichte Messverlauf'   
  }, 
  plotOptions: { 
    line: {  
      animation: false, 
      dataLabels: {  
        enabled: true  
      } 
    } 
  }, 
  xAxis: { 
    tickInterval: 1,
    type: 'logarithmic'
  }, 
  yAxis: { 
    title: {  
      text: 'Plato'  
    } 
  }, 
  credits: { 
    enabled: false  
} 
}); 

//Plot gravity in the tilt chart 
function plotTilt(value, name){ 
var x = (new Date()).getTime()
var y = Number(value); 
chartA.series[0].update({
  name: name
});
if(chartA.series[0].data.length > 40) { 
  chartA.series[0].addPoint([x, y], true, true, true); 
} else { 
  chartA.series[0].addPoint([x, y], true, false, true); 
} 
} 

//Plot gravity in the gravity chart 
function plotTemp(value, name){ 
var x = (new Date()).getTime()
var y = Number(value); 
chartT.series[0].update({
  name: name
});
if(chartT.series[0].data.length > 40) { 
  chartT.series[0].addPoint([x, y], true, true, true); 
} else { 
  chartT.series[0].addPoint([x, y], true, false, true); 
} 
} 

//Plot Temperature in the temperature chart 
function plotBattery(value, name){ 
var x = (new Date()).getTime()
var y = Number(value); 
chartB.series[0].update({
  name: name
});
if(chartB.series[0].data.length > 40) { 
  chartB.series[0].addPoint([x, y], true, true, true); 
} else { 
  chartB.series[0].addPoint([x, y], true, false, true); 
} 
} 

//Plot Battery in the battery chart 
function plotGravity(value, name){ 
var x = (new Date()).getTime()
var y = Number(value); 
chartG.series[0].update({
  name: name
});
if(chartG.series[0].data.length > 40) { 
  chartG.series[0].addPoint([x, y], true, true, true); 
} else { 
  chartG.series[0].addPoint([x, y], true, false, true); 
} 
} 

// Function to get current readings on the web page when it loads  
function getReadings() { 
var xhr = new XMLHttpRequest(); 
xhr.onreadystatechange = function() { 
  if (this.readyState == 4 && this.status == 200) { 
    console.log("["+this.responseText.slice(0, -1)+"]");
    var myObj = JSON.parse("["+this.responseText.slice(0, -1)+"]"); 
    console.log(myObj); 
    var len = myObj.length; 
    console.log(len); 
    if(len > 40) { 
      for(var i = len-40; i<len; i++){ 
        plotTilt(myObj[i].angle, myObj[i].name); 
        plotTemp(myObj[i].temperature, myObj[i].name); 
        plotBattery(myObj[i].battery, myObj[i].name); 
        plotGravity(myObj[i].gravity, myObj[i].name);
        // Speichern des letzten Indexes
        var lastI = i;
      } 
    } 
    else { 
      for(var i = 0; i<len; i++){ 
        plotTilt(myObj[i].angle, myObj[i].name); 
        plotTemp(myObj[i].temperature, myObj[i].name); 
        plotBattery(myObj[i].battery, myObj[i].name); 
        plotGravity(myObj[i].gravity, myObj[i].name);
        // Speichern des letzten Indexes
        var lastI = i;
      } 
    } 
      // Hier ist der letzte Index verfügbar
      console.log("Letztes i: " + lastI);
  } 
};  
xhr.open("GET", "/view-data", true); 
xhr.send(); 
} 

if (!!window.EventSource) { 
var source = new EventSource('/events'); 
   
source.addEventListener('open', function(e) { 
  console.log("Events Connected"); 
}, false); 

source.addEventListener('error', function(e) { 
  if (e.target.readyState != EventSource.OPEN) { 
    console.log("Events Disconnected"); 
  } 
}, false); 
   
source.addEventListener('message', function(e) { 
  console.log("message", e.data); 
}, false); 
   
source.addEventListener('new_readings', function(e) { 
  console.log("new_readings", e.data); 
  var myObj = JSON.parse(e.data); 
  console.log(myObj);  
  plotTilt(myObj.angle, myObj.name); 
  plotTemp(myObj.temperature, myObj.name); 
  plotBattery(myObj.battery, myObj.name); 
  plotGravity(myObj.gravity, myObj.name);
}, false); 
}
