/**************************************************************

    "iMonitor"
    By Adrian S. <>

    "Data controller"

 **************************************************************/

#ifndef DATA_H
#define DATA_H

#include "AsyncJson.h"
#include <EEPROM.h>
#include "FS.h"
#include "SD.h"
#include "SPI.h"

class Data
{
public:
    Data();
    String setViewData(String data);
    String getDataForDashboard(const char *settingsPath, const char *lastDataPath);
    String getData(const char *path);
    void appendData(String data, const char *dataPath);
    void deleteAllData(const char *path);
    void requestDataFromFile(AsyncWebServerRequest *request, const char *path);
    void downloadDataFromFile(AsyncWebServerRequest *request, const char *path);
    void initSettings(const char *settingsPath);
    bool isDataFileExists(const char *path);
    bool isSDExists();

private:
    void startFS();
    void endFS();
    String getDataFromFile(fs::FS &fs, const char *path);
    void safeDataToFile(fs::FS &fs, const char *path, const char *message);
    void deleteDataFromFile(fs::FS &fs, const char *path);
};

#endif